Index: src/org/armedbear/lisp/JavaObject.java
===================================================================
--- src/org/armedbear/lisp/JavaObject.java	(revision 14598)
+++ src/org/armedbear/lisp/JavaObject.java	(working copy)
@@ -364,20 +364,24 @@
             StringBuilder sb
                 = new StringBuilder(c.isArray() ? "jarray" : c.getName());
             sb.append(' ');
-            String ts = obj.toString();
-            int length = -1;
-            LispObject stringLength = _JAVA_OBJECT_TO_STRING_LENGTH.symbolValueNoThrow();
-            if (stringLength instanceof Fixnum) {
-                length = Fixnum.getValue(stringLength);
+            try {
+                String ts = obj.toString();
+                int length = -1;
+                LispObject stringLength = _JAVA_OBJECT_TO_STRING_LENGTH.symbolValueNoThrow();
+                if (stringLength instanceof Fixnum) {
+                    length = Fixnum.getValue(stringLength);
+                }
+                if (length < 0) {
+                    sb.append(ts);
+                }else if (ts.length() > length) { 
+                    // use '....' to not confuse user with PPRINT conventions
+                    sb.append(ts.substring(0, length)).append("...."); 
+                } else {
+                    sb.append(ts);
+                }
+            } catch (Exception e) {
+                return serror(new JavaException(e));
             }
-            if (length < 0) {
-                sb.append(ts);
-            }else if (ts.length() > length) { 
-                // use '....' to not confuse user with PPRINT conventions
-                sb.append(ts.substring(0, length)).append("...."); 
-            } else {
-                sb.append(ts);
-            }
             s = sb.toString();
         } else {
             s = "null";
